: Class ResultSet

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## ModSQL
Class ResultSet

    java.lang.Object
      |
      +--ModSQL.ResultSet

All Implemented Interfaces:
  ResultSet

public class ResultSet
extends Object
implements ResultSet

A ResultSet provides access to a table of data. A ResultSet object is usually generated by executing a Statement.

A ResultSet maintains a cursor pointing to its current row of data. Initially the cursor is positioned before the first row. The 'next' method moves the cursor to the next row.

The getXXX methods retrieve column values for the current row. You can retrieve values either using the index number of the column, or by using the name of the column. In general using the column index will be more efficient. Columns are numbered from 1.

For maximum portability, ResultSet columns within each row should be read in left-to-right order and each column should be read only once.

For the getXXX methods, the JDBC driver attempts to convert the underlying data to the specified Java type and returns a suitable Java value. See the JDBC specification for allowable mappings from SQL types to Java types with the ResultSet.getXXX methods.

Column names used as input to getXXX methods are case insensitive. When performing a getXXX using a column name, if several columns have the same name, then the value of the first matching column will be returned. The column name option is designed to be used when column names are used in the SQL query. For columns that are NOT explicitly named in the query, it is best to use column numbers. If column names were used there is no way for the programmer to guarantee that they actually refer to the intended columns.

A ResultSet is automatically closed by the Statement that generated it when that Statement is closed, re-executed, or is used to retrieve the next result from a sequence of multiple results.

The number, types and properties of a ResultSet's columns are provided by the ResulSetMetaData object returned by the getMetaData method.

Author:
  chris.studholme@utoronto.ca
See Also:
  `PreparedStatement.executeQuery(java.lang.String)`, `PreparedStatement.getResultSet()`, `ResultSetMetaData`

Field Summary
`protected boolean` | `beforefirst` True if we are before the first row.
`protected boolean` | `lastNull` True if last value retrieved was null.
`protected Select` | `query` Query that generated this result set.
`protected PreparedStatement` | `statement` Statement that was used to generate this result set.

Fields inherited from interface java.sql.ResultSet
`CONCUR_READ_ONLY, CONCUR_UPDATABLE, FETCH_FORWARD, FETCH_REVERSE, FETCH_UNKNOWN, TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, TYPE_SCROLL_SENSITIVE`

Constructor Summary
`protected` | `ResultSet(Select query, PreparedStatement statement)` Constructor.

Method Summary
`boolean` | `absolute(int row)` Move to an absolute row number in the result set.
`void` | `afterLast()` Moves to the end of the result set, just after the last row.
`void` | `beforeFirst()` Moves to the front of the result set, just before the first row.
`void` | `cancelRowUpdates()` The cancelRowUpdates() method may be called after calling an updateXXX() method(s) and before calling updateRow() to rollback the updates made to a row.
`void` | `clearWarnings()` After this call getWarnings returns null until a new warning is reported for this ResultSet.
`void` | `close()` In some cases, it is desirable to immediately release a ResultSet's database and JDBC resources instead of waiting for this to happen when it is automatically closed; the close method provides this immediate release.
`void` | `deleteRow()` Delete the current row from the result set and the underlying database.
`int` | `findColumn(String columnName)` Map a Resultset column name to a ResultSet column index.
`boolean` | `first()` Moves to the first row in the result set.
`Array` | `getArray(int i)` Get an array column.
`Array` | `getArray(String colName)` Get an array column.
`InputStream` | `getAsciiStream(int columnIndex)` A column value can be retrieved as a stream of ASCII characters and then read in chunks from the stream.
`InputStream` | `getAsciiStream(String columnName)` A column value can be retrieved as a stream of ASCII characters and then read in chunks from the stream.
`BigDecimal` | `getBigDecimal(int columnIndex)` Get the value of a column in the current row as a java.math.BigDecimal object.
`BigDecimal` | `getBigDecimal(int columnIndex, int scale)` Deprecated.
`BigDecimal` | `getBigDecimal(String columnName)` Get the value of a column in the current row as a java.math.BigDecimal object.
`BigDecimal` | `getBigDecimal(String columnName, int scale)` Deprecated.
`InputStream` | `getBinaryStream(int columnIndex)` A column value can be retrieved as a stream of uninterpreted bytes and then read in chunks from the stream.
`InputStream` | `getBinaryStream(String columnName)` A column value can be retrieved as a stream of uninterpreted bytes and then read in chunks from the stream.
`Blob` | `getBlob(int i)` Get a BLOB column.
`Blob` | `getBlob(String colName)` Get a BLOB column.
`boolean` | `getBoolean(int columnIndex)` Get the value of a column in the current row as a Java boolean.
`boolean` | `getBoolean(String columnName)` Get the value of a column in the current row as a Java boolean.
`byte` | `getByte(int columnIndex)` Get the value of a column in the current row as a Java byte.
`byte` | `getByte(String columnName)` Get the value of a column in the current row as a Java byte.
`byte[]` | `getBytes(int columnIndex)` Get the value of a column in the current row as a Java byte array.
`byte[]` | `getBytes(String columnName)` Get the value of a column in the current row as a Java byte array.
`Reader` | `getCharacterStream(int columnIndex)` Get the value of a column in the current row as a java.io.Reader.
`Reader` | `getCharacterStream(String columnName)` Get the value of a column in the current row as a java.io.Reader.
`Clob` | `getClob(int i)` Get a CLOB column.
`Clob` | `getClob(String colName)` Get a CLOB column.
`int` | `getConcurrency()` Return the concurrency of this result set.
`String` | `getCursorName()` Get the name of the SQL cursor used by this ResultSet.
`Date` | `getDate(int columnIndex)` Get the value of a column in the current row as a java.sql.Date object.
`Date` | `getDate(int columnIndex, Calendar cal)` Get the value of a column in the current row as a java.sql.Date object.
`Date` | `getDate(String columnName)` Get the value of a column in the current row as a java.sql.Date object.
`Date` | `getDate(String columnName, Calendar cal)` Get the value of a column in the current row as a java.sql.Date object.
`double` | `getDouble(int columnIndex)` Get the value of a column in the current row as a Java double.
`double` | `getDouble(String columnName)` Get the value of a column in the current row as a Java double.
`int` | `getFetchDirection()` Return the fetch direction for this result set.
`int` | `getFetchSize()` Return the fetch size for this result set.
`float` | `getFloat(int columnIndex)` Get the value of a column in the current row as a Java float.
`float` | `getFloat(String columnName)` Get the value of a column in the current row as a Java float.
`int` | `getInt(int columnIndex)` Get the value of a column in the current row as a Java int.
`int` | `getInt(String columnName)` Get the value of a column in the current row as a Java int.
`long` | `getLong(int columnIndex)` Get the value of a column in the current row as a Java long.
`long` | `getLong(String columnName)` Get the value of a column in the current row as a Java long.
`ResultSetMetaData` | `getMetaData()` The number, types and properties of a ResultSet's columns are provided by the getMetaData method.
`Object` | `getObject(int columnIndex)` Get the value of a column in the current row as a Java object.
`Object` | `getObject(int i, Map map)` Returns the value of column @i as a Java object.
`Object` | `getObject(String columnName)` Get the value of a column in the current row as a Java object.
`Object` | `getObject(String colName, Map map)` Returns the value of column @i as a Java object.
`Ref` | `getRef(int i)` Get a REF(<structured-type>) column.
`Ref` | `getRef(String colName)` Get a REF(<structured-type>) column.
`int` | `getRow()` Determine the current row number.
`short` | `getShort(int columnIndex)` Get the value of a column in the current row as a Java short.
`short` | `getShort(String columnName)` Get the value of a column in the current row as a Java short.
`Statement` | `getStatement()` Return the Statement that produced the ResultSet.
`String` | `getString(int columnIndex)` Get the value of a column in the current row as a Java String.
`String` | `getString(String columnName)` Get the value of a column in the current row as a Java String.
`Time` | `getTime(int columnIndex)` Get the value of a column in the current row as a java.sql.Time object.
`Time` | `getTime(int columnIndex, Calendar cal)` Get the value of a column in the current row as a java.sql.Time object.
`Time` | `getTime(String columnName)` Get the value of a column in the current row as a java.sql.Time object.
`Time` | `getTime(String columnName, Calendar cal)` Get the value of a column in the current row as a java.sql.Time object.
`Timestamp` | `getTimestamp(int columnIndex)` Get the value of a column in the current row as a java.sql.Timestamp object.
`Timestamp` | `getTimestamp(int columnIndex, Calendar cal)` Get the value of a column in the current row as a java.sql.Timestamp object.
`Timestamp` | `getTimestamp(String columnName)` Get the value of a column in the current row as a java.sql.Timestamp object.
`Timestamp` | `getTimestamp(String columnName, Calendar cal)` Get the value of a column in the current row as a java.sql.Timestamp object.
`int` | `getType()` Return the type of this result set.
`InputStream` | `getUnicodeStream(int columnIndex)` Deprecated.
`InputStream` | `getUnicodeStream(String columnName)` Deprecated.
`SQLWarning` | `getWarnings()` The first warning reported by calls on this ResultSet is returned.
`void` | `insertRow()` Insert the contents of the insert row into the result set and the database.
`boolean` | `isAfterLast()` Determine if the cursor is after the last row in the result set.
`boolean` | `isBeforeFirst()` Determine if the cursor is before the first row in the result set.
`boolean` | `isFirst()` Determine if the cursor is on the first row of the result set.
`boolean` | `isLast()` Determine if the cursor is on the last row of the result set.
`boolean` | `last()` Moves to the last row in the result set.
`void` | `moveToCurrentRow()` Move the cursor to the remembered cursor position, usually the current row.
`void` | `moveToInsertRow()` Move to the insert row.
`boolean` | `next()` A ResultSet is initially positioned before its first row; the first call to next makes the first row the current row; the second call makes the second row the current row, etc.
`boolean` | `previous()` Moves to the previous row in the result set.
`void` | `refreshRow()` Refresh the value of the current row with its current value in the database.
`boolean` | `relative(int rows)` Moves a relative number of rows, either positive or negative.
`boolean` | `rowDeleted()` Determine if this row has been deleted.
`boolean` | `rowInserted()` Determine if the current row has been inserted.
`boolean` | `rowUpdated()` Determine if the current row has been updated.
`void` | `setFetchDirection(int direction)` Give a hint as to the direction in which the rows in this result set will be processed.
`void` | `setFetchSize(int rows)` Give the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for this result set.
`void` | `updateAsciiStream(int columnIndex, InputStream x, int length)` Update a column with an ascii stream value.
`void` | `updateAsciiStream(String columnName, InputStream x, int length)` Update a column with an ascii stream value.
`void` | `updateBigDecimal(int columnIndex, BigDecimal x)` Update a column with a BigDecimal value.
`void` | `updateBigDecimal(String columnName, BigDecimal x)` Update a column with a BigDecimal value.
`void` | `updateBinaryStream(int columnIndex, InputStream x, int length)` Update a column with a binary stream value.
`void` | `updateBinaryStream(String columnName, InputStream x, int length)` Update a column with a binary stream value.
`void` | `updateBoolean(int columnIndex, boolean x)` Update a column with a boolean value.
`void` | `updateBoolean(String columnName, boolean x)` Update a column with a boolean value.
`void` | `updateByte(int columnIndex, byte x)` Update a column with a byte value.
`void` | `updateByte(String columnName, byte x)` Update a column with a byte value.
`void` | `updateBytes(int columnIndex, byte[] x)` Update a column with a byte array value.
`void` | `updateBytes(String columnName, byte[] x)` Update a column with a byte array value.
`void` | `updateCharacterStream(int columnIndex, Reader x, int length)` Update a column with a character stream value.
`void` | `updateCharacterStream(String columnName, Reader reader, int length)` Update a column with a character stream value.
`void` | `updateDate(int columnIndex, Date x)` Update a column with a Date value.
`void` | `updateDate(String columnName, Date x)` Update a column with a Date value.
`void` | `updateDouble(int columnIndex, double x)` Update a column with a Double value.
`void` | `updateDouble(String columnName, double x)` Update a column with a double value.
`void` | `updateFloat(int columnIndex, float x)` Update a column with a float value.
`void` | `updateFloat(String columnName, float x)` Update a column with a float value.
`void` | `updateInt(int columnIndex, int x)` Update a column with an integer value.
`void` | `updateInt(String columnName, int x)` Update a column with an integer value.
`void` | `updateLong(int columnIndex, long x)` Update a column with a long value.
`void` | `updateLong(String columnName, long x)` Update a column with a long value.
`void` | `updateNull(int columnIndex)` Give a nullable column a null value.
`void` | `updateNull(String columnName)` Update a column with a null value.
`void` | `updateObject(int columnIndex, Object x)` Update a column with an Object value.
`void` | `updateObject(int columnIndex, Object x, int scale)` Update a column with an Object value.
`void` | `updateObject(String columnName, Object x)` Update a column with an Object value.
`void` | `updateObject(String columnName, Object x, int scale)` Update a column with an Object value.
`void` | `updateRow()` Update the underlying database with the new contents of the current row.
`void` | `updateShort(int columnIndex, short x)` Update a column with a short value.
`void` | `updateShort(String columnName, short x)` Update a column with a short value.
`void` | `updateString(int columnIndex, String x)` Update a column with a String value.
`void` | `updateString(String columnName, String x)` Update a column with a String value.
`void` | `updateTime(int columnIndex, Time x)` Update a column with a Time value.
`void` | `updateTime(String columnName, Time x)` Update a column with a Time value.
`void` | `updateTimestamp(int columnIndex, Timestamp x)` Update a column with a Timestamp value.
`void` | `updateTimestamp(String columnName, Timestamp x)` Update a column with a Timestamp value.
`boolean` | `wasNull()` A column may have the value of SQL NULL; wasNull reports whether the last column read had this special value.

Methods inherited from class java.lang.Object
`, clone, equals, finalize, getClass, hashCode, notify, notifyAll, registerNatives, toString, wait, wait, wait`

Field Detail

### query

    protected Select query

  Query that generated this result set.

### statement

    protected PreparedStatement statement

  Statement that was used to generate this result set.

### lastNull

    protected boolean lastNull

  True if last value retrieved was null.

### beforefirst

    protected boolean beforefirst

  True if we are before the first row.

Constructor Detail

### ResultSet

    protected ResultSet(Select query,
                        PreparedStatement statement)

  Constructor.
  Parameters:
    `query` - query to generate result set from
    `statement` - statement used to execute query

Method Detail

### next

    public boolean next()
                 throws SQLException

  A ResultSet is initially positioned before its first row; the first call to next makes the first row the current row; the second call makes the second row the current row, etc.

  If an input stream from the previous row is open, it is implicitly closed. The ResultSet's warning chain is cleared when a new row is read.

  Specified by:
    `next` in interface `ResultSet`
  Returns:
    true if the new current row is valid; false if there are no more rows
  Throws:
    `SQLException` - if a database-access error occurs.

### close

    public void close()
               throws SQLException

  In some cases, it is desirable to immediately release a ResultSet's database and JDBC resources instead of waiting for this to happen when it is automatically closed; the close method provides this immediate release.

  Note: A ResultSet is automatically closed by the Statement that generated it when that Statement is closed, re-executed, or is used to retrieve the next result from a sequence of multiple results. A ResultSet is also automatically closed when it is garbage collected.

  Specified by:
    `close` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs.

### wasNull

    public boolean wasNull()
                    throws SQLException

  A column may have the value of SQL NULL; wasNull reports whether the last column read had this special value. Note that you must first call getXXX on a column to try to read its value and then call wasNull() to find if the value was the SQL NULL.
  Specified by:
    `wasNull` in interface `ResultSet`
  Returns:
    true if last column read was SQL NULL
  Throws:
    `SQLException` - if a database-access error occurs.

### getObject

    public Object getObject(int columnIndex)
                     throws SQLException

  Get the value of a column in the current row as a Java object.

  This method will return the value of the given column as a Java object. The type of the Java object will be the default Java Object type corresponding to the column's SQL type, following the mapping specified in the JDBC spec.

  This method may also be used to read datatabase specific abstract data types.

  Specified by:
    `getObject` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    A java.lang.Object holding the column value.
  Throws:
    `SQLException` - if a database-access error occurs.

### getString

    public String getString(int columnIndex)
                     throws SQLException

  Get the value of a column in the current row as a Java String.
  Specified by:
    `getString` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getBoolean

    public boolean getBoolean(int columnIndex)
                       throws SQLException

  Get the value of a column in the current row as a Java boolean.
  Specified by:
    `getBoolean` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is false
  Throws:
    `SQLException` - if a database-access error occurs.

### getByte

    public byte getByte(int columnIndex)
                 throws SQLException

  Get the value of a column in the current row as a Java byte.
  Specified by:
    `getByte` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getShort

    public short getShort(int columnIndex)
                   throws SQLException

  Get the value of a column in the current row as a Java short.
  Specified by:
    `getShort` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getInt

    public int getInt(int columnIndex)
               throws SQLException

  Get the value of a column in the current row as a Java int.
  Specified by:
    `getInt` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getLong

    public long getLong(int columnIndex)
                 throws SQLException

  Get the value of a column in the current row as a Java long.
  Specified by:
    `getLong` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getFloat

    public float getFloat(int columnIndex)
                   throws SQLException

  Get the value of a column in the current row as a Java float.
  Specified by:
    `getFloat` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getDouble

    public double getDouble(int columnIndex)
                     throws SQLException

  Get the value of a column in the current row as a Java double.
  Specified by:
    `getDouble` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getBigDecimal

    public BigDecimal getBigDecimal(int columnIndex,
                                    int scale)
                             throws SQLException

  Deprecated.

  Get the value of a column in the current row as a java.lang.BigDecimal object.
  Specified by:
    `getBigDecimal` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `scale` - the number of digits to the right of the decimal
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getBytes

    public byte[] getBytes(int columnIndex)
                    throws SQLException

  Get the value of a column in the current row as a Java byte array. The bytes represent the raw values returned by the driver.
  Specified by:
    `getBytes` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getDate

    public Date getDate(int columnIndex)
                 throws SQLException

  Get the value of a column in the current row as a java.sql.Date object.
  Specified by:
    `getDate` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getTime

    public Time getTime(int columnIndex)
                 throws SQLException

  Get the value of a column in the current row as a java.sql.Time object.
  Specified by:
    `getTime` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getTimestamp

    public Timestamp getTimestamp(int columnIndex)
                           throws SQLException

  Get the value of a column in the current row as a java.sql.Timestamp object.
  Specified by:
    `getTimestamp` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getAsciiStream

    public InputStream getAsciiStream(int columnIndex)
                               throws SQLException

  A column value can be retrieved as a stream of ASCII characters and then read in chunks from the stream. This method is particularly suitable for retrieving large LONGVARCHAR values. The JDBC driver will do any necessary conversion from the database format into ASCII.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a get method implicitly closes the stream. . Also, a stream may return 0 for available() whether there is data available or not.

  Specified by:
    `getAsciiStream` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    a Java input stream that delivers the database column value as a stream of one byte ASCII characters. If the value is SQL NULL then the result is null.
  Throws:
    `SQLException` - if a database-access error occurs.

### getUnicodeStream

    public InputStream getUnicodeStream(int columnIndex)
                                 throws SQLException

  Deprecated.

  A column value can be retrieved as a stream of Unicode characters and then read in chunks from the stream. This method is particularly suitable for retrieving large LONGVARCHAR values. The JDBC driver will do any necessary conversion from the database format into Unicode.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a get method implicitly closes the stream. . Also, a stream may return 0 for available() whether there is data available or not.

  Specified by:
    `getUnicodeStream` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    a Java input stream that delivers the database column value as a stream of two byte Unicode characters. If the value is SQL NULL then the result is null.
  Throws:
    `SQLException` - if a database-access error occurs.

### getBinaryStream

    public InputStream getBinaryStream(int columnIndex)
                                throws SQLException

  A column value can be retrieved as a stream of uninterpreted bytes and then read in chunks from the stream. This method is particularly suitable for retrieving large LONGVARBINARY values.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a get method implicitly closes the stream. Also, a stream may return 0 for available() whether there is data available or not.

  Specified by:
    `getBinaryStream` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    a Java input stream that delivers the database column value as a stream of uninterpreted bytes. If the value is SQL NULL then the result is null.
  Throws:
    `SQLException` - if a database-access error occurs.

### getObject

    public Object getObject(String columnName)
                     throws SQLException

  Get the value of a column in the current row as a Java object.

  This method will return the value of the given column as a Java object. The type of the Java object will be the default Java Object type corresponding to the column's SQL type, following the mapping specified in the JDBC spec.

  This method may also be used to read datatabase specific abstract data types.

  Specified by:
    `getObject` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    A java.lang.Object holding the column value.
  Throws:
    `SQLException` - if a database-access error occurs.

### getString

    public String getString(String columnName)
                     throws SQLException

  Get the value of a column in the current row as a Java String.
  Specified by:
    `getString` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getBoolean

    public boolean getBoolean(String columnName)
                       throws SQLException

  Get the value of a column in the current row as a Java boolean.
  Specified by:
    `getBoolean` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is false
  Throws:
    `SQLException` - if a database-access error occurs.

### getByte

    public byte getByte(String columnName)
                 throws SQLException

  Get the value of a column in the current row as a Java byte.
  Specified by:
    `getByte` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getShort

    public short getShort(String columnName)
                   throws SQLException

  Get the value of a column in the current row as a Java short.
  Specified by:
    `getShort` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getInt

    public int getInt(String columnName)
               throws SQLException

  Get the value of a column in the current row as a Java int.
  Specified by:
    `getInt` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getLong

    public long getLong(String columnName)
                 throws SQLException

  Get the value of a column in the current row as a Java long.
  Specified by:
    `getLong` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getFloat

    public float getFloat(String columnName)
                   throws SQLException

  Get the value of a column in the current row as a Java float.
  Specified by:
    `getFloat` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getDouble

    public double getDouble(String columnName)
                     throws SQLException

  Get the value of a column in the current row as a Java double.
  Specified by:
    `getDouble` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is 0
  Throws:
    `SQLException` - if a database-access error occurs.

### getBigDecimal

    public BigDecimal getBigDecimal(String columnName,
                                    int scale)
                             throws SQLException

  Deprecated.

  Get the value of a column in the current row as a java.lang.BigDecimal object.
  Specified by:
    `getBigDecimal` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
    `scale` - the number of digits to the right of the decimal
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getBytes

    public byte[] getBytes(String columnName)
                    throws SQLException

  Get the value of a column in the current row as a Java byte array. The bytes represent the raw values returned by the driver.
  Specified by:
    `getBytes` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getDate

    public Date getDate(String columnName)
                 throws SQLException

  Get the value of a column in the current row as a java.sql.Date object.
  Specified by:
    `getDate` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getTime

    public Time getTime(String columnName)
                 throws SQLException

  Get the value of a column in the current row as a java.sql.Time object.
  Specified by:
    `getTime` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getTimestamp

    public Timestamp getTimestamp(String columnName)
                           throws SQLException

  Get the value of a column in the current row as a java.sql.Timestamp object.
  Specified by:
    `getTimestamp` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getAsciiStream

    public InputStream getAsciiStream(String columnName)
                               throws SQLException

  A column value can be retrieved as a stream of ASCII characters and then read in chunks from the stream. This method is particularly suitable for retrieving large LONGVARCHAR values. The JDBC driver will do any necessary conversion from the database format into ASCII.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a get method implicitly closes the stream.

  Specified by:
    `getAsciiStream` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    a Java input stream that delivers the database column value as a stream of one byte ASCII characters. If the value is SQL NULL then the result is null.
  Throws:
    `SQLException` - if a database-access error occurs.

### getUnicodeStream

    public InputStream getUnicodeStream(String columnName)
                                 throws SQLException

  Deprecated.

  A column value can be retrieved as a stream of Unicode characters and then read in chunks from the stream. This method is particularly suitable for retrieving large LONGVARCHAR values. The JDBC driver will do any necessary conversion from the database format into Unicode.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a get method implicitly closes the stream.

  Specified by:
    `getUnicodeStream` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    a Java input stream that delivers the database column value as a stream of two byte Unicode characters. If the value is SQL NULL then the result is null.
  Throws:
    `SQLException` - if a database-access error occurs.

### getBinaryStream

    public InputStream getBinaryStream(String columnName)
                                throws SQLException

  A column value can be retrieved as a stream of uninterpreted bytes and then read in chunks from the stream. This method is particularly suitable for retrieving large LONGVARBINARY values.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a get method implicitly closes the stream.

  Specified by:
    `getBinaryStream` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
  Returns:
    a Java input stream that delivers the database column value as a stream of uninterpreted bytes. If the value is SQL NULL then the result is null.
  Throws:
    `SQLException` - if a database-access error occurs.

### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

  The first warning reported by calls on this ResultSet is returned. Subsequent ResultSet warnings will be chained to this SQLWarning.

  The warning chain is automatically cleared each time a new row is read.

  Note: This warning chain only covers warnings caused by ResultSet methods. Any warning caused by statement methods (such as reading OUT parameters) will be chained on the Statement object.

  Specified by:
    `getWarnings` in interface `ResultSet`
  Returns:
    the first SQLWarning or null
  Throws:
    `SQLException` - if a database-access error occurs.

### clearWarnings

    public void clearWarnings()
                       throws SQLException

  After this call getWarnings returns null until a new warning is reported for this ResultSet.
  Specified by:
    `clearWarnings` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs.

### getCursorName

    public String getCursorName()
                         throws SQLException

  Get the name of the SQL cursor used by this ResultSet.

  In SQL, a result table is retrieved through a cursor that is named. The current row of a result can be updated or deleted using a positioned update/delete statement that references the cursor name.

  JDBC supports this SQL feature by providing the name of the SQL cursor used by a ResultSet. The current row of a ResultSet is also the current row of this SQL cursor.

  Note: If positioned update is not supported a SQLException is thrown

  Specified by:
    `getCursorName` in interface `ResultSet`
  Returns:
    the ResultSet's SQL cursor name
  Throws:
    `SQLException` - if a database-access error occurs.

### getMetaData

    public ResultSetMetaData getMetaData()
                                  throws SQLException

  The number, types and properties of a ResultSet's columns are provided by the getMetaData method.
  Specified by:
    `getMetaData` in interface `ResultSet`
  Returns:
    the description of a ResultSet's columns
  Throws:
    `SQLException` - if a database-access error occurs.

### findColumn

    public int findColumn(String columnName)
                   throws SQLException

  Map a Resultset column name to a ResultSet column index.
  Specified by:
    `findColumn` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
  Returns:
    the column index
  Throws:
    `SQLException` - if a database-access error occurs.

### getCharacterStream

    public Reader getCharacterStream(int columnIndex)
                              throws SQLException

  Get the value of a column in the current row as a java.io.Reader.

  Specified by:
    `getCharacterStream` in interface `ResultSet`

### getCharacterStream

    public Reader getCharacterStream(String columnName)
                              throws SQLException

  Get the value of a column in the current row as a java.io.Reader.

  Specified by:
    `getCharacterStream` in interface `ResultSet`

### getBigDecimal

    public BigDecimal getBigDecimal(int columnIndex)
                             throws SQLException

  Get the value of a column in the current row as a java.math.BigDecimal object.
  Specified by:
    `getBigDecimal` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value (full precision); if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getBigDecimal

    public BigDecimal getBigDecimal(String columnName)
                             throws SQLException

  Get the value of a column in the current row as a java.math.BigDecimal object.
  Specified by:
    `getBigDecimal` in interface `ResultSet`

### isBeforeFirst

    public boolean isBeforeFirst()
                          throws SQLException

  Determine if the cursor is before the first row in the result set.

  Specified by:
    `isBeforeFirst` in interface `ResultSet`
  Returns:
    true if before the first row, false otherwise. Returns false when the result set contains no rows.
  Throws:
    `SQLException` - if a database-access error occurs.

### isAfterLast

    public boolean isAfterLast()
                        throws SQLException

  Determine if the cursor is after the last row in the result set.

  Specified by:
    `isAfterLast` in interface `ResultSet`
  Returns:
    true if after the last row, false otherwise. Returns false when the result set contains no rows.
  Throws:
    `SQLException` - if a database-access error occurs.

### isFirst

    public boolean isFirst()
                    throws SQLException

  Determine if the cursor is on the first row of the result set.

  Specified by:
    `isFirst` in interface `ResultSet`
  Returns:
    true if on the first row, false otherwise.
  Throws:
    `SQLException` - if a database-access error occurs.

### isLast

    public boolean isLast()
                   throws SQLException

  Determine if the cursor is on the last row of the result set. Note: Calling isLast() may be expensive since the JDBC driver might need to fetch ahead one row in order to determine whether the current row is the last row in the result set.

  Specified by:
    `isLast` in interface `ResultSet`
  Returns:
    true if on the last row, false otherwise.
  Throws:
    `SQLException` - if a database-access error occurs.

### beforeFirst

    public void beforeFirst()
                     throws SQLException

  Moves to the front of the result set, just before the first row. Has no effect if the result set contains no rows.

  Specified by:
    `beforeFirst` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, or result set type is TYPE_FORWARD_ONLY

### afterLast

    public void afterLast()
                   throws SQLException

  Moves to the end of the result set, just after the last row. Has no effect if the result set contains no rows.

  Specified by:
    `afterLast` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, or result set type is TYPE_FORWARD_ONLY.

### first

    public boolean first()
                  throws SQLException

  Moves to the first row in the result set.

  Specified by:
    `first` in interface `ResultSet`
  Returns:
    true if on a valid row, false if no rows in the result set.
  Throws:
    `SQLException` - if a database-access error occurs, or result set type is TYPE_FORWARD_ONLY.

### last

    public boolean last()
                 throws SQLException

  Moves to the last row in the result set.

  Specified by:
    `last` in interface `ResultSet`
  Returns:
    true if on a valid row, false if no rows in the result set.
  Throws:
    `SQLException` - if a database-access error occurs, or result set type is TYPE_FORWARD_ONLY.

### getRow

    public int getRow()
               throws SQLException

  Determine the current row number. The first row is number 1, the second number 2, etc.

  Specified by:
    `getRow` in interface `ResultSet`
  Returns:
    the current row number, else return 0 if there is no current row
  Throws:
    `SQLException` - if a database-access error occurs.

### absolute

    public boolean absolute(int row)
                     throws SQLException

  Move to an absolute row number in the result set.

  If row is positive, moves to an absolute row with respect to the beginning of the result set. The first row is row 1, the second is row 2, etc.

  If row is negative, moves to an absolute row position with respect to the end of result set. For example, calling absolute(-1) positions the cursor on the last row, absolute(-2) indicates the next-to-last row, etc.

  An attempt to position the cursor beyond the first/last row in the result set, leaves the cursor before/after the first/last row, respectively.

  Note: Calling absolute(1) is the same as calling first(). Calling absolute(-1) is the same as calling last().

  Specified by:
    `absolute` in interface `ResultSet`
  Returns:
    true if on the result set, false if off.
  Throws:
    `SQLException` - if a database-access error occurs, or row is 0, or result set type is TYPE_FORWARD_ONLY.

### relative

    public boolean relative(int rows)
                     throws SQLException

  Moves a relative number of rows, either positive or negative. Attempting to move beyond the first/last row in the result set positions the cursor before/after the the first/last row. Calling relative(0) is valid, but does not change the cursor position.

  Note: Calling relative(1) is different than calling next() since is makes sense to call next() when there is no current row, for example, when the cursor is positioned before the first row or after the last row of the result set.

  Specified by:
    `relative` in interface `ResultSet`
  Returns:
    true if on a row, false otherwise.
  Throws:
    `SQLException` - if a database-access error occurs, or there is no current row, or result set type is TYPE_FORWARD_ONLY.

### previous

    public boolean previous()
                     throws SQLException

  Moves to the previous row in the result set.

  Note: previous() is not the same as relative(-1) since it makes sense to call previous() when there is no current row.

  Specified by:
    `previous` in interface `ResultSet`
  Returns:
    true if on a valid row, false if off the result set.
  Throws:
    `SQLException` - if a database-access error occurs, or result set type is TYPE_FORWAR_DONLY.

### setFetchDirection

    public void setFetchDirection(int direction)
                           throws SQLException

  Give a hint as to the direction in which the rows in this result set will be processed. The initial value is determined by the statement that produced the result set. The fetch direction may be changed at any time.
  Specified by:
    `setFetchDirection` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, or the result set type is TYPE_FORWARD_ONLY and direction is not FETCH_FORWARD.

### getFetchDirection

    public int getFetchDirection()
                          throws SQLException

  Return the fetch direction for this result set.
  Specified by:
    `getFetchDirection` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs

### setFetchSize

    public void setFetchSize(int rows)
                      throws SQLException

  Give the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for this result set. If the fetch size specified is zero, then the JDBC driver ignores the value, and is free to make its own best guess as to what the fetch size should be. The default value is set by the statement that creates the result set. The fetch size may be changed at any time.
  Specified by:
    `setFetchSize` in interface `ResultSet`
  Parameters:
    `rows` - the number of rows to fetch
  Throws:
    `SQLException` - if a database-access error occurs, or the condition 0 <= rows <= this.getMaxRows() is not satisfied.

### getFetchSize

    public int getFetchSize()
                     throws SQLException

  Return the fetch size for this result set.
  Specified by:
    `getFetchSize` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs

### getType

    public int getType()
                throws SQLException

  Return the type of this result set. The type is determined based on the statement that created the result set.
  Specified by:
    `getType` in interface `ResultSet`
  Returns:
    TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, or TYPE_SCROLL_SENSITIVE
  Throws:
    `SQLException` - if a database-access error occurs

### getConcurrency

    public int getConcurrency()
                       throws SQLException

  Return the concurrency of this result set. The concurrency used is determined by the statement that created the result set.
  Specified by:
    `getConcurrency` in interface `ResultSet`
  Returns:
    the concurrency type, CONCUR_READ_ONLY, etc.
  Throws:
    `SQLException` - if a database-access error occurs

### rowUpdated

    public boolean rowUpdated()
                       throws SQLException

  Determine if the current row has been updated. The value returned depends on whether or not the result set can detect updates.
  Specified by:
    `rowUpdated` in interface `ResultSet`
  Returns:
    true if the row has been visibly updated by the owner or another, and updates are detected
  Throws:
    `SQLException` - if a database-access error occurs
  See Also:
    `DatabaseMetaData.updatesAreDetected(int)`

### rowInserted

    public boolean rowInserted()
                        throws SQLException

  Determine if the current row has been inserted. The value returned depends on whether or not the result set can detect visible inserts.
  Specified by:
    `rowInserted` in interface `ResultSet`
  Returns:
    true if inserted and inserts are detected
  Throws:
    `SQLException` - if a database-access error occurs
  See Also:
    `DatabaseMetaData.insertsAreDetected(int)`

### rowDeleted

    public boolean rowDeleted()
                       throws SQLException

  Determine if this row has been deleted. A deleted row may leave a visible "hole" in a result set. This method can be used to detect holes in a result set. The value returned depends on whether or not the result set can detect deletions.
  Specified by:
    `rowDeleted` in interface `ResultSet`
  Returns:
    true if deleted and deletes are detected
  Throws:
    `SQLException` - if a database-access error occurs
  See Also:
    `DatabaseMetaData.deletesAreDetected(int)`

### updateNull

    public void updateNull(int columnIndex)
                    throws SQLException

  Give a nullable column a null value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateNull` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Throws:
    `SQLException` - if a database-access error occurs

### updateBoolean

    public void updateBoolean(int columnIndex,
                              boolean x)
                       throws SQLException

  Update a column with a boolean value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateBoolean` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateByte

    public void updateByte(int columnIndex,
                           byte x)
                    throws SQLException

  Update a column with a byte value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateByte` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateShort

    public void updateShort(int columnIndex,
                            short x)
                     throws SQLException

  Update a column with a short value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateShort` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateInt

    public void updateInt(int columnIndex,
                          int x)
                   throws SQLException

  Update a column with an integer value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateInt` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateLong

    public void updateLong(int columnIndex,
                           long x)
                    throws SQLException

  Update a column with a long value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateLong` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateFloat

    public void updateFloat(int columnIndex,
                            float x)
                     throws SQLException

  Update a column with a float value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateFloat` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateDouble

    public void updateDouble(int columnIndex,
                             double x)
                      throws SQLException

  Update a column with a Double value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateDouble` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateBigDecimal

    public void updateBigDecimal(int columnIndex,
                                 BigDecimal x)
                          throws SQLException

  Update a column with a BigDecimal value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateBigDecimal` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateString

    public void updateString(int columnIndex,
                             String x)
                      throws SQLException

  Update a column with a String value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateString` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateBytes

    public void updateBytes(int columnIndex,
                            byte[] x)
                     throws SQLException

  Update a column with a byte array value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateBytes` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateDate

    public void updateDate(int columnIndex,
                           Date x)
                    throws SQLException

  Update a column with a Date value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateDate` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateTime

    public void updateTime(int columnIndex,
                           Time x)
                    throws SQLException

  Update a column with a Time value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateTime` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateTimestamp

    public void updateTimestamp(int columnIndex,
                                Timestamp x)
                         throws SQLException

  Update a column with a Timestamp value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateTimestamp` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                                  InputStream x,
                                  int length)
                           throws SQLException

  Update a column with an ascii stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateAsciiStream` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
    `length` - the length of the stream
  Throws:
    `SQLException` - if a database-access error occurs

### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                                   InputStream x,
                                   int length)
                            throws SQLException

  Update a column with a binary stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateBinaryStream` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
    `length` - the length of the stream
  Throws:
    `SQLException` - if a database-access error occurs

### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                                      Reader x,
                                      int length)
                               throws SQLException

  Update a column with a character stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateCharacterStream` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
    `length` - the length of the stream
  Throws:
    `SQLException` - if a database-access error occurs

### updateObject

    public void updateObject(int columnIndex,
                             Object x,
                             int scale)
                      throws SQLException

  Update a column with an Object value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateObject` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
    `scale` - For java.sql.Types.DECIMAL or java.sql.Types.NUMERIC types this is the number of digits after the decimal. For all other types this value will be ignored.
  Throws:
    `SQLException` - if a database-access error occurs

### updateObject

    public void updateObject(int columnIndex,
                             Object x)
                      throws SQLException

  Update a column with an Object value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateObject` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateNull

    public void updateNull(String columnName)
                    throws SQLException

  Update a column with a null value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateNull` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
  Throws:
    `SQLException` - if a database-access error occurs

### updateBoolean

    public void updateBoolean(String columnName,
                              boolean x)
                       throws SQLException

  Update a column with a boolean value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateBoolean` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateByte

    public void updateByte(String columnName,
                           byte x)
                    throws SQLException

  Update a column with a byte value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateByte` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateShort

    public void updateShort(String columnName,
                            short x)
                     throws SQLException

  Update a column with a short value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateShort` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateInt

    public void updateInt(String columnName,
                          int x)
                   throws SQLException

  Update a column with an integer value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateInt` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateLong

    public void updateLong(String columnName,
                           long x)
                    throws SQLException

  Update a column with a long value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateLong` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateFloat

    public void updateFloat(String columnName,
                            float x)
                     throws SQLException

  Update a column with a float value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateFloat` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateDouble

    public void updateDouble(String columnName,
                             double x)
                      throws SQLException

  Update a column with a double value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateDouble` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateBigDecimal

    public void updateBigDecimal(String columnName,
                                 BigDecimal x)
                          throws SQLException

  Update a column with a BigDecimal value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateBigDecimal` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateString

    public void updateString(String columnName,
                             String x)
                      throws SQLException

  Update a column with a String value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateString` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateBytes

    public void updateBytes(String columnName,
                            byte[] x)
                     throws SQLException

  Update a column with a byte array value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateBytes` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateDate

    public void updateDate(String columnName,
                           Date x)
                    throws SQLException

  Update a column with a Date value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateDate` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateTime

    public void updateTime(String columnName,
                           Time x)
                    throws SQLException

  Update a column with a Time value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateTime` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateTimestamp

    public void updateTimestamp(String columnName,
                                Timestamp x)
                         throws SQLException

  Update a column with a Timestamp value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateTimestamp` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### updateAsciiStream

    public void updateAsciiStream(String columnName,
                                  InputStream x,
                                  int length)
                           throws SQLException

  Update a column with an ascii stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateAsciiStream` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
    `length` - of the stream
  Throws:
    `SQLException` - if a database-access error occurs

### updateBinaryStream

    public void updateBinaryStream(String columnName,
                                   InputStream x,
                                   int length)
                            throws SQLException

  Update a column with a binary stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateBinaryStream` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
    `length` - of the stream
  Throws:
    `SQLException` - if a database-access error occurs

### updateCharacterStream

    public void updateCharacterStream(String columnName,
                                      Reader reader,
                                      int length)
                               throws SQLException

  Update a column with a character stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateCharacterStream` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
    `length` - of the stream
  Throws:
    `SQLException` - if a database-access error occurs

### updateObject

    public void updateObject(String columnName,
                             Object x,
                             int scale)
                      throws SQLException

  Update a column with an Object value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateObject` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
    `scale` - For java.sql.Types.DECIMAL or java.sql.Types.NUMERIC types this is the number of digits after the decimal. For all other types this value will be ignored.
  Throws:
    `SQLException` - if a database-access error occurs

### updateObject

    public void updateObject(String columnName,
                             Object x)
                      throws SQLException

  Update a column with an Object value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.
  Specified by:
    `updateObject` in interface `ResultSet`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
  Throws:
    `SQLException` - if a database-access error occurs

### insertRow

    public void insertRow()
                   throws SQLException

  Insert the contents of the insert row into the result set and the database. Must be on the insert row when this method is called.
  Specified by:
    `insertRow` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, if called when not on the insert row, or if all non-nullable columns in the insert row have not been given a value

### updateRow

    public void updateRow()
                   throws SQLException

  Update the underlying database with the new contents of the current row. Cannot be called when on the insert row.
  Specified by:
    `updateRow` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, or if called when on the insert row

### deleteRow

    public void deleteRow()
                   throws SQLException

  Delete the current row from the result set and the underlying database. Cannot be called when on the insert row.
  Specified by:
    `deleteRow` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, or if called when on the insert row.

### refreshRow

    public void refreshRow()
                    throws SQLException

  Refresh the value of the current row with its current value in the database. Cannot be called when on the insert row. The refreshRow() method provides a way for an application to explicitly tell the JDBC driver to refetch a row(s) from the database. An application may want to call refreshRow() when caching or prefetching is being done by the JDBC driver to fetch the latest value of a row from the database. The JDBC driver may actually refresh multiple rows at once if the fetch size is greater than one. All values are refetched subject to the transaction isolation level and cursor sensitivity. If refreshRow() is called after calling updateXXX(), but before calling updateRow() then the updates made to the row are lost. Calling refreshRow() frequently will likely slow performance.
  Specified by:
    `refreshRow` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, or if called when on the insert row.

### cancelRowUpdates

    public void cancelRowUpdates()
                          throws SQLException

  The cancelRowUpdates() method may be called after calling an updateXXX() method(s) and before calling updateRow() to rollback the updates made to a row. If no updates have been made or updateRow() has already been called, then this method has no effect.
  Specified by:
    `cancelRowUpdates` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, or if called when on the insert row.

### moveToInsertRow

    public void moveToInsertRow()
                         throws SQLException

  Move to the insert row. The current cursor position is remembered while the cursor is positioned on the insert row. The insert row is a special row associated with an updatable result set. It is essentially a buffer where a new row may be constructed by calling the updateXXX() methods prior to inserting the row into the result set. Only the updateXXX(), getXXX(), and insertRow() methods may be called when the cursor is on the insert row. All of the columns in a result set must be given a value each time this method is called before calling insertRow(). UpdateXXX()must be called before getXXX() on a column.
  Specified by:
    `moveToInsertRow` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, or the result set is not updatable

### moveToCurrentRow

    public void moveToCurrentRow()
                          throws SQLException

  Move the cursor to the remembered cursor position, usually the current row. Has no effect unless the cursor is on the insert row.
  Specified by:
    `moveToCurrentRow` in interface `ResultSet`
  Throws:
    `SQLException` - if a database-access error occurs, or the result set is not updatable

### getStatement

    public Statement getStatement()
                           throws SQLException

  Return the Statement that produced the ResultSet.
  Specified by:
    `getStatement` in interface `ResultSet`
  Returns:
    the Statment that produced the result set, or null if the result was produced some other way.
  Throws:
    `SQLException` - if a database-access error occurs

### getObject

    public Object getObject(int i,
                            Map map)
                     throws SQLException

  Returns the value of column @i as a Java object. Use the
  Specified by:
    `getObject` in interface `ResultSet`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
    `map` - the mapping from SQL type names to Java classes
  Returns:
    an object representing the SQL value

### getRef

    public Ref getRef(int i)
               throws SQLException

  Get a REF(<structured-type>) column.
  Specified by:
    `getRef` in interface `ResultSet`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
  Returns:
    an object representing data of an SQL REF type

### getBlob

    public Blob getBlob(int i)
                 throws SQLException

  Get a BLOB column.
  Specified by:
    `getBlob` in interface `ResultSet`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
  Returns:
    an object representing a BLOB

### getClob

    public Clob getClob(int i)
                 throws SQLException

  Get a CLOB column.
  Specified by:
    `getClob` in interface `ResultSet`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
  Returns:
    an object representing a CLOB

### getArray

    public Array getArray(int i)
                   throws SQLException

  Get an array column.
  Specified by:
    `getArray` in interface `ResultSet`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
  Returns:
    an object representing an SQL array

### getObject

    public Object getObject(String colName,
                            Map map)
                     throws SQLException

  Returns the value of column @i as a Java object. Use the
  Specified by:
    `getObject` in interface `ResultSet`
  Parameters:
    `colName` - the column name
    `map` - the mapping from SQL type names to Java classes
  Returns:
    an object representing the SQL value

### getRef

    public Ref getRef(String colName)
               throws SQLException

  Get a REF(<structured-type>) column.
  Specified by:
    `getRef` in interface `ResultSet`
  Parameters:
    `colName` - the column name
  Returns:
    an object representing data of an SQL REF type

### getBlob

    public Blob getBlob(String colName)
                 throws SQLException

  Get a BLOB column.
  Specified by:
    `getBlob` in interface `ResultSet`
  Parameters:
    `colName` - the column name
  Returns:
    an object representing a BLOB

### getClob

    public Clob getClob(String colName)
                 throws SQLException

  Get a CLOB column.
  Specified by:
    `getClob` in interface `ResultSet`
  Parameters:
    `colName` - the column name
  Returns:
    an object representing a CLOB

### getArray

    public Array getArray(String colName)
                   throws SQLException

  Get an array column.
  Specified by:
    `getArray` in interface `ResultSet`
  Parameters:
    `colName` - the column name
  Returns:
    an object representing an SQL array

### getDate

    public Date getDate(int columnIndex,
                        Calendar cal)
                 throws SQLException

  Get the value of a column in the current row as a java.sql.Date object. Use the calendar to construct an appropriate millisecond value for the Date, if the underlying database doesn't store timezone information.
  Specified by:
    `getDate` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `cal` - the calendar to use in constructing the date
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getDate

    public Date getDate(String columnName,
                        Calendar cal)
                 throws SQLException

  Get the value of a column in the current row as a java.sql.Date object. Use the calendar to construct an appropriate millisecond value for the Date, if the underlying database doesn't store timezone information.
  Specified by:
    `getDate` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
    `cal` - the calendar to use in constructing the date
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getTime

    public Time getTime(int columnIndex,
                        Calendar cal)
                 throws SQLException

  Get the value of a column in the current row as a java.sql.Time object. Use the calendar to construct an appropriate millisecond value for the Time, if the underlying database doesn't store timezone information.
  Specified by:
    `getTime` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `cal` - the calendar to use in constructing the time
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getTime

    public Time getTime(String columnName,
                        Calendar cal)
                 throws SQLException

  Get the value of a column in the current row as a java.sql.Time object. Use the calendar to construct an appropriate millisecond value for the Time, if the underlying database doesn't store timezone information.
  Specified by:
    `getTime` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
    `cal` - the calendar to use in constructing the time
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getTimestamp

    public Timestamp getTimestamp(int columnIndex,
                                  Calendar cal)
                           throws SQLException

  Get the value of a column in the current row as a java.sql.Timestamp object. Use the calendar to construct an appropriate millisecond value for the Timestamp, if the underlying database doesn't store timezone information.
  Specified by:
    `getTimestamp` in interface `ResultSet`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `cal` - the calendar to use in constructing the timestamp
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

### getTimestamp

    public Timestamp getTimestamp(String columnName,
                                  Calendar cal)
                           throws SQLException

  Get the value of a column in the current row as a java.sql.Timestamp object. Use the calendar to construct an appropriate millisecond value for the Timestamp, if the underlying database doesn't store timezone information.
  Specified by:
    `getTimestamp` in interface `ResultSet`
  Parameters:
    `columnName` - is the SQL name of the column
    `cal` - the calendar to use in constructing the timestamp
  Returns:
    the column value; if the value is SQL NULL, the result is null
  Throws:
    `SQLException` - if a database-access error occurs.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD